/*
This block is heavily based on the Quote of the Day block
This block grabs the list of top books from blackwells
for a given topic randomly selected from the
$TOPICS array.

The contents of the $TOPICS array, the $cachelife value in seconds
currently set to an hour, the path to your cache file (which needs
to be writable by the web user) and the Blackwells affiliate id shown 
at $id need to be changed. 

Considering that Blackwells is primarily UK based and an academic bookseller
this block may have narrower appeal than the Amazon equivalent but at 
least it is an alternative.

Installation is straightforward change the $TOPICS, $cache and $id values 
to suit then add a php block as Admin called phpblock_blackwells. I've 
called the title of the block 'Books' but then I am incredibly uncreative 
this week.

The function itself is added to lib-custom.php in the 
/path/to/geeklog/system subdirectory of your geeklog installation. 

Extra Feature...

If you set the $slice value to TRUE the code will only show 5 out of the 
10 titles in the cached list. The 'trick' is that these 5 are randomly selected
giving a more dynamic and shorter list.


An example of this block can be found at http://josi.spaceless.com/

good luck

*/

function phpblock_blackwells() {
    /* 
    * change these values to suit 
    */    
    $TOPICS = array(
		'information systems',
        'sociology',
        'anthropology',
        'architecture',
        'design',
    );
    $id = "3176151072";   /*
This block is heavily based on the Quote of the Day block
This block grabs the list of top books from blackwells
for a given topic randomly selected from the
$TOPICS array.

The contents of the $TOPICS array, the $cachelife value in seconds
currently set to an hour, the path to your cache file (which needs
to be writable by the web user) and the Blackwells affiliate id shown 
at $id need to be changed. 

Considering that Blackwells is primarily UK based and an academic bookseller
this block may have narrower appeal than the Amazon equivalent but at 
least it is an alternative.

Installation is straightforward change the $TOPICS, $cache and $id values 
to suit then add a php block as Admin called phpblock_blackwells. I've 
called the title of the block 'Books' but then I am incredibly uncreative 
this week.

The function itself is added to lib-custom.php in the 
/path/to/geeklog/system subdirectory of your geeklog installation. 

Extra Feature...

If you set the $slice value to TRUE the code will only show 5 out of the 
10 titles in the cached list. The 'trick' is that these 5 are randomly selected
giving a more dynamic and shorter list.


An example of this block can be found at http://josi.spaceless.com/
with the slice feature set to true.

good luck

*/

function phpblock_blackwells() {
    /* 
    * change these values to suit 
    */    
    $TOPICS = array(
		'information systems',
        'sociology',
        'anthropology',
        'architecture',
        'design',
    );
    $id = "3176151072";   
    $cachelife = "3600"; 
    $cache ="/path/to/geeklog/cache/blackwells.dat";
   
    $slice = TRUE;

    /*
    * shouldn't need to change anything else beyond here
    * except perhaps the HTML format
    */
    
    // Work out the size of the TOPICS arrau and
    // then select one
    $topiclength = count($TOPICS);
    srand((double)microtime()*1000000);
    $arrayindex = rand(0,$topiclength);
    $term = $TOPICS[$arrayindex];    
    $term = str_replace(' ','+',$term);
        
    $cachenew = false;

    // Compare the cache file's creation time
    // against the cachelife value.
    // Also make sure that the size of the cachefile is 
    // bigger than 50 bytes.
    if (file_exists($cache) == TRUE) {
            $filemod     = filemtime($cache);
            $filemodtime = date("F j Y h:i:s A", filemtime($cache));
            $currenttime = getdate(time());
            $currentdate = $currenttime["0"];
            if (($currentdate - $filemod < $cachelife) && (filesize($cache) > 50)) {
                $cachenew = true;
            } 
    } 

    $content = "";  
    if ($cachenew == FALSE) {
		$url ="http://search.blackwell.co.uk/b2s/servlet/search?type=title&term=$term&source=$id";
    } else {
        $url = $cache;
    }        

    // Get the appropriate file (cached date or from blackwells)       
    $fhurl = fopen($url, "r");
    if ((isset($fhurl)) && ($fhurl != false)) {
        while(!feof($fhurl)) {
            $content .=fgets($fhurl,80);
        } // while
    }
    fclose($fhurl);
    
    // Cache web gathered data
    if ($cachenew == FALSE) {       
            // write to cache file
            $cf = fopen($cache, "w");
            $fp = fwrite($cf, $content);
            fclose($cf);
    }

    // split the individual lines into a formatted piece of HTML
    $books = explode("\n", $content);   
    // Need to change this if you do not want a bullet point list
    $retstr .= "<ul>";
    if ($slice) {
        $bookslength = count($books);
        $booksize = $booklength /2; 
        $sliceindex = rand(0,$booksize);
        $books = array_slice($books,$sliceindex,$booksize);
    }  
    foreach ($books as $value) {
       $book = explode("|", $value); 
       if ($book[5] && $book[2]) {
           // This is the data for each entry
           // $book[2] is the title
           // $book[1] is the author
           // $book[3] is the price
           // $book[4] is the availability
           // $book[5] is the url
           // there is some other data that comes over too but I'm
           // not sure what it is.    
           $retstr .= "<li><a target=newbook href=$book[5]><i>$book[2]</i></a>, $book[1] [&pound;$book[3], $book[4]]\n";
       }
    }
    $retstr .= "</ul>\n";
    
    // Return the formatter HTML block.
    return $retstr;
} 

    $cachelife = "3600"; 
    $cache ="/usr/home/spaceless/www/josi/cache/blackwells.dat";
   
    $slice = TRUE;

    /*
    * shouldn't need to change anything else beyond here
    * except perhaps the HTML format
    */
    
    // Work out the size of the TOPICS arrau and
    // then select one
    $topiclength = count($TOPICS);
    srand((double)microtime()*1000000);
    $arrayindex = rand(0,$topiclength);
    $term = $TOPICS[$arrayindex];    
    $term = str_replace(' ','+',$term);
        
    $cachenew = false;

    // Compare the cache file's creation time
    // against the cachelife value.
    // Also make sure that the size of the cachefile is 
    // bigger than 50 bytes.
    if (file_exists($cache) == TRUE) {
            $filemod     = filemtime($cache);
            $filemodtime = date("F j Y h:i:s A", filemtime($cache));
            $currenttime = getdate(time());
            $currentdate = $currenttime["0"];
            if (($currentdate - $filemod < $cachelife) && (filesize($cache) > 50)) {
                $cachenew = true;
            } 
    } 

    $content = "";  
    if ($cachenew == FALSE) {
		$url ="http://search.blackwell.co.uk/b2s/servlet/search?type=title&term=$term&source=$id";
    } else {
        $url = $cache;
    }        

    // Get the appropriate file (cached date or from blackwells)       
    $fhurl = fopen($url, "r");
    if ((isset($fhurl)) && ($fhurl != false)) {
        while(!feof($fhurl)) {
            $content .=fgets($fhurl,80);
        } // while
    }
    fclose($fhurl);
    
    // Cache web gathered data
    if ($cachenew == FALSE) {       
            // write to cache file
            $cf = fopen($cache, "w");
            $fp = fwrite($cf, $content);
            fclose($cf);
    }

    // split the individual lines into a formatted piece of HTML
    $books = explode("\n", $content);   
    // Need to change this if you do not want a bullet point list
    $retstr .= "<ul>";
    if ($slice) {
        $bookslength = count($books);
        $booksize = intval($bookslength /2); 
        $sliceindex = rand(0,$booksize);
        $books = array_slice($books,$sliceindex,$booksize);
    }  
    foreach ($books as $value) {
       $book = explode("|", $value); 
       if ($book[5] && $book[2]) {
           // This is the data for each entry
           // $book[2] is the title
           // $book[1] is the author
           // $book[3] is the price
           // $book[4] is the availability
           // $book[5] is the url
           // there is some other data that comes over too but I'm
           // not sure what it is.    
           $retstr .= "<li><a target=newbook href=$book[5]><i>$book[2]</i></a>, $book[1] [&pound;$book[3], $book[4]]\n";
       }
    }
    $retstr .= "</ul>\n";
    
    // Return the formatter HTML block.
    return $retstr;
} 
